<?php

/**
* Fortune comamnd factory
*/
require_once($_CONF['path'] . 'plugins/fortune/fCommandFactory.class.php');

/**
* The controller portion of the Model-View-Controller (MVC).
*
* This controls behavior of pages within the administration section
* of the fortune plugin
*
* @author Tony Bibbs <tony AT geeklog NET>
*
*/
class controller {
    /**
    * @access private
    */
    var $_cmd = '';

    /**
    * @access private
    */
    var $_successPage;

    /**
    * Constructor
    *
    * Sets up the command and subsequent actions
    *
    * @author Tony Bibbs <tony AT geeklog DOT net>
    * 
    */
    function controller()
    {
        global $PHP_SELF;

        if (empty($_POST['cmd'])) {
            $cmd = $_GET['cmd'];
        } else {
            $cmd = $_POST['cmd'];
        }

        switch ($cmd) {
            case 'install':
                $this->_cmd = $cmd;
                break;
            case 'uninstall':
                $this->_cmd = $cmd;
                break;
            case 'saveQuote':
                $this->_cmd = 'saveFortune';
                $this->_successPage = $PHP_SELF;
                break;
            case 'showEditor':
                $this->_cmd = 'getEditor';
                break;
            case 'showFortunes':
                $this->_cmd = 'getFortunes';
                break;
            case 'approveItem':
                $this->_cmd = 'approveFortune';
                $this->_successPage = $PHP_SELF . '?cmd=listFortunes';
                break;
            case 'deleteItem':
                $this->_cmd = 'deleteFortune';
                $this->_successPage = $_PHP_SELF . '?cmd=listFortunes';
                break;
            default:
                $this->_cmd = 'listFortunes';
        }

    }

    /**
    * Hands work off to the model portion of the MVC
    *
    * @author Tony Bibbs <tony AT geeklog DOT net>
    * @access public
    * @return string HTML output
    *
    */
    function doAction() 
    {
        $cmd = &fCommandFactory::getCommand($this->_cmd);

        if (empty($this->_successPage)) {
            return $cmd->executeCommand();
        } else {
            $retval = $cmd->executeCommand();
            if (empty($retval)) { 
                echo COM_refresh($this->_successPage);
                exit;
            } else {
                return $retval;
            }
        }
    }
    
}

?>
